﻿Imports RCK02Net

'****************************************** HELP
'RCK1.P_ProgramID (e.g. "4AD14721F3698705BA618E2C" )
'   * Activation Key encryption logic will depend on this key
'   * ProgramID Must have 24 Characters
'   * All Characters of ProgramID Must be 0 To 9 OR 'A' To 'F'
'
'RCK1.P_Sequence (e.g. "ABCDEFGHIJKLMNOPQRSTUVWXYZ" this is default value)
'   * for advance protection use this property otherwise not require
'   * Sequence String length Must be 26 characters
'   * All characters must be between ('A' to 'Z') OR (0 to 9)
'   * No character must repeat
'   * Here output character Key(Activation Code Or MID Code) is map as "A as A,B as B,
'       C as C....as on Z as Z". you can change maping value as per your requirement
'   * E.g.
'          RCK1.P_Sequence = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
'          RCK1.P_Sequence = "ABCDEFGHIJKLMNOPQ123456789"
'          RCK1.P_Sequence = "ZYXWVUTSRQPONMLKJIHGFEDCBA"
'
'RCK1.P_SoftwareID (e.g. 1 is Default value)
'   *   If you have more than 1 software use this property(if you changed P_ProgramID in
'       all your softwares then you don't set this property)
'   * SoftwareID Must Be Between 1 To 26
'   * E.g.
'           RCK1.P_SoftwareID = 1 (For School Software)
'           RCK1.P_SoftwareID = 2 (For Account Software)
'           RCK1.P_SoftwareID = 3 (For Payslip)
'
'############### NOTE ################
'IN DEMO VERSION
'YOU CAN NOT CHANGE VALUE OF FOLLOWING PROPERTY. VALUE OF FOLLOWING PROPERTY IS READONLY IN DEMO VERSION
'   RCK1.P_ProgramID = "0123456789ABCDEF01234567"
'   RCK1.P_Sequence = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
'   RCK1.P_SoftwareID = 1
'#####################################
'******************************************
Public Class FrmKeyGen
    Public HardwareSerialOfClientPC As String

    Public Sub New()
        Try
            ' This call is required by the Windows Form Designer.
            InitializeComponent()
            ' Add any initialization after the InitializeComponent() call.
            RCK1.Load_RCKProperty()

            RCK1.P_ProgramID = "0123456789ABCDEF01234567"       ' Activation Key encryption logic will depend on this key
            RCK1.P_Sequence = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"      ' enter Sequence charactors. output character Key(Activation Code Or MID Code) is map as "A as A,B as B,C as C....as on Z as Z" but you can change this sequence by this parameter (e.g. ABCDEFGHIJKLMNOPQ123456789 )
            RCK1.P_SoftwareID = 1  ' 1 For School Software, 2 For Account Software, 3 For Payslip ...As on

            '*** return Miscellaneous Serial No which you can use here or any other perpose
            Dim HDDModule1 As String = ""
            TxtMacAddress.Text = RCK1.M_GetMacAddress
            TxtBaseboardNo.Text = RCK1.M_GetMotherBoardSerialNo
            TxtHDD.Text = RCK1.M_GetHDDDSerialNo(0, HDDModule1)
            TxtModule.Text = HDDModule1
            TxtProcess.Text = RCK1.M_GetProcessorId
            '***
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub cmdExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdExit.Click
        End
    End Sub

    Private Sub CmdUnprotectMID_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdUnprotectMID.Click
        Try
            Dim SoftwareID As Integer
            Dim ErrorNo As Integer
            Dim ExtraStringFromClientPC As String = ""
            Dim ExtraStringFromClientPCWith As Integer = 20

            ErrorNo = RCK1.M_UnProtectMID4(TxtMID.Text, SoftwareID, ExtraStringFromClientPC, ExtraStringFromClientPCWith)

            'Parameters description
            'TxtMID.Text                    ->  Pass MID Code (which you have received from your client)
            'SoftwareID                     ->  Return software ID
            'ExtraStringFromClientPC        ->  Return Extra 20 characters Which you have passed when
            '                                   MID Code is generated (which contain hardware Sr.no.of
            '                                   client PC And Other information  as per your requirement)
            'ExtraStringFromClientPCWith    ->  Pass Width of ExtraStringFromClientPC parameter
            'function return  0 For MID Code unprotect Successfully

            If ErrorNo <> 0 Then
                Select Case ErrorNo
                    Case -1
                        MsgBox("Width of MID Code must be 26 characters", vbOKOnly + vbExclamation, "")
                    Case -2
                        MsgBox("Every Character of MID Code must be between 'A' to 'Z'", vbOKOnly + vbExclamation, "My App")
                        ' As per your RCK1.SequenceNo
                        '(e.g. if RCK1.SequenceNo = 'ABCDEFGHIJKLMNOP0123456789' then 'A' to 'P' OR 0 TO 9 )
                    Case -3
                        MsgBox("Invalid MID Code(Typing mistake) or this MID Code is not for this application ")
                End Select
            End If
            If ErrorNo = 0 Then
                Select Case SoftwareID
                    Case 1
                        LblSoftwareName.Text = "School Software"
                    Case 2
                        LblSoftwareName.Text = "Account Software"
                    Case 3
                        LblSoftwareName.Text = "Payslip Software"
                End Select
                TxtClientSoftwareID.Text = SoftwareID

                'ExtraStringFromClientPC variable contain following detail
                '############## Start Mid code description
                ' 1 to 15   -> 5-5-5  (base board,Hard disk,ProcesserID)
                ' 16        ->        Software Type
                ' 17 to 20  ->        Party Licence No
                '############## End Mid code description
                TxtClientBaseBoardNo.Text = Mid(ExtraStringFromClientPC, 1, 5)
                TxtClientHarddiskNo.Text = Mid(ExtraStringFromClientPC, 6, 5)
                TxtClientProcesserID.Text = Mid(ExtraStringFromClientPC, 11, 5)
                HardwareSerialOfClientPC = Mid(ExtraStringFromClientPC, 1, 15)
                '***** Software Type (16 char)
                Dim lDec As Decimal = AbcToNum(Mid(ExtraStringFromClientPC, 16, 1))
                If lDec >= 0 And lDec < 5 Then
                    cmbSoftType.SelectedIndex = lDec
                End If
                '***** License No (17->20 char) 4 
                lDec = AbcToNum(Mid(ExtraStringFromClientPC, 17, 4))
                txtLicNo.Text = CInt(lDec)
                '***** 
            End If
            If ErrorNo = 0 Then
                MsgBox("Success")
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub CmdAct_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdAct.Click
        Try
            If HardwareSerialOfClientPC = "" Then
                MessageBox.Show("First Enter MID code And Unprotect it")
                TxtMID.Focus()
                Exit Sub
            End If
            If cmbSoftType.SelectedIndex < 0 Then
                MessageBox.Show("Select Software Type")
                cmbSoftType.Focus()
                Exit Sub
            End If
            If chkBit1Lan.Checked AndAlso Val(txtLanUsers.Text) <= 1 Then
                MessageBox.Show("Lan User must be grater then 1")
                txtLanUsers.Focus()
                Exit Sub
            End If
            If Val(txtLicNo.Text) = 0 And chkIsDemo.Checked = False Then
                MessageBox.Show("Enter License No")
                txtLicNo.Focus()
                Exit Sub
            End If
            If chkIsDemo.Checked And Val(txtDays.Text) <= 0 Then
                MessageBox.Show("Enter Demo Days")
                txtDays.Focus()
                Exit Sub
            End If
            If chkBit1Lan.Checked AndAlso Not (Val(txtLanUsers.Text) > 1 And Val(txtLanUsers.Text) < 676) Then
                MessageBox.Show("Node must be 1 to 675")
                txtLanUsers.Focus()
                Exit Sub
            End If
            If chkIsDemo.Checked = False And Not (Val(txtLicNo.Text) >= 1 And Val(txtLicNo.Text) <= 456975) Then
                MessageBox.Show("License No must be 1 to 456975")
                txtLicNo.Focus()
                Exit Sub
            End If
            If dtpExpDate.Value > DateSerial(2013, 1, 1).AddYears(27) Then
                MessageBox.Show("Date must be 01-01-2013 To " & Format(DateSerial(2013, 1, 1).AddYears(27), "dd-MM-yyyy"))
                dtpExpDate.Focus()
                Exit Sub
            End If

            Dim ActivationCode As String
            Dim ExtraChar As String
            ExtraChar = HardwareSerialOfClientPC  ' Pass Hardware Serial No of client PC by Activation Code(as per requirement)
            '***** Software Type (1 char)
            ExtraChar &= NumToAbc(cmbSoftType.SelectedIndex, 1)
            '***** Last Date (2->3 char)  0 for permanent activation, 1 to 676 to temperaroty activation days
            Dim lDec As Decimal
            If chkIsDemo.Checked Then
                lDec = DateDiff(DateInterval.Day, DateSerial(2013, 1, 1), dtpExpDate.Value)
                lDec = Math.Ceiling(lDec / 15)
                dtpExpDate.Value = DateSerial(2013, 1, 1).AddDays(lDec * 15)
            Else
                lDec = 0
            End If
            If Not (lDec >= 0 And lDec < 676) Then
                MessageBox.Show("value Must be 0 to 676")
                Exit Sub
            End If
            ExtraChar &= NumToAbc(lDec, 2)
            '***** Last bin 4 5 (4 char)(5 char) 
            Dim Bin4 As String = ""
            Dim Bin5 As String = ""
            Bin4 &= IIf(chkBit1Lan.Checked, "1", "0")
            Bin4 &= IIf(chkBit2SMS.Checked, "1", "0")
            Bin4 &= IIf(chkBit3Barcode.Checked, "1", "0")
            Bin4 &= IIf(chkBit4.Checked, "1", "0")

            Bin5 &= IIf(chkBit5.Checked, "1", "0")
            Bin5 &= IIf(chkBit6.Checked, "1", "0")
            Bin5 &= IIf(chkBit7.Checked, "1", "0")
            Bin5 &= IIf(chkBit8.Checked, "1", "0")
            ExtraChar &= NumToAbc(BinToDec(Bin4), 1) & NumToAbc(BinToDec(Bin5), 1)
            '***** (Start) License No (6->9 char) 4 
            ExtraChar &= NumToAbc(Val(txtLicNo.Text), 4)    ' License no must be 1 to 456975   (26*26*26*26)
            '***** (End) License No (6->9 char) 4 
            '***** (Start) Nodes (10->11 char) 2 
            If chkBit1Lan.Checked Then
                ExtraChar &= NumToAbc(Val(txtLanUsers.Text), 2)  ' Node must be 1 to 676  (26*26)
            Else
                ExtraChar &= NumToAbc(1, 2)
            End If
            '***** (End) Nodes (10->11 char) 2 

            Dim ExtracterWidthOfMIDCode As Integer = 20 ' for mid code
            Dim ExtraCharWidthOfAct As Integer = 26     ' for activation code

            ActivationCode = RCK1.M_GetAct4(Trim(TxtMID.Text), ExtracterWidthOfMIDCode, ExtraChar, ExtraCharWidthOfAct)


            'PARAMETERS DESCRIPTION
            '
            'TxtMID.Text                    -> Pass MID Code (which you have received from your client)
            'ExtracterWidthOfMIDCode        -> Pass Width of Extracter character which you have pass when mid code generated
            'ExtraChar                      -> Pass 20 Extra characters (which contain 
            '                                  Hardware Sr.no of client PC+Other information as per your requirement)
            'ExtraCharWidthOfAct            -> Pass Width of ExtraChar(parameter)
            '
            'Function    Return Activation Code    Activation Code Width is 33 (26 Extra character + 7 Internal Character = 33 Character)
            '         Or Return following error no.
            '            
            '
            ' "-1" For width of MID Code(parameter) must be 26 characters (20 extracter + 6 internal character = 26 Mid Code character )
            ' "-2" For Every character of MID Code must be "A" TO "Z"
            ' "-3" For Invalid MID code(Typing mistake) or this MID code is not for this application
            ' "-4" For Width of ExtraChar(paramater) of Mid code must be 20 characters

            ' "-5" For Width of ExtraChar(paramater) of Activation code must be 26 characters
            ' "-6" For Every character of ExtraChar(paramater) of Activation code must be between 'A' to 'Z'

            ' "-7" For Width of ExtraChar(paramater) of Activation code must be between 1 to 30

            'e.g. Return 'KOWCJWQ-FINXY-XDUPY-VEFER-KQYZG'
            If ActivationCode.Length = 33 Then
                TxtAct.Text = PastDasIntoString(ActivationCode, "6999") 'this function return (E.g. KLUDOQ-MYANSDWMA-LHFJNYSCU-LWNWXTOAS)
            Else
                TxtAct.Text = ActivationCode
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub chkIsDemo_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkIsDemo.CheckedChanged
        lblDays.Enabled = chkIsDemo.Checked
        lblExpDate.Enabled = chkIsDemo.Checked
        txtDays.Enabled = chkIsDemo.Checked
        dtpExpDate.Enabled = chkIsDemo.Checked
    End Sub

    Private Sub txtDays_Leave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtDays.Leave
        dtpExpDate.Value = Now.Date.AddDays(Val(txtDays.Text))
        Call CalculateDemoDate()
    End Sub
    Private Sub dtpExpDate_Leave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles dtpExpDate.Leave
        Call CalculateDemoDate()
    End Sub
    Private Sub CalculateDemoDate()
        Try
            Dim lDec As Decimal
            lDec = DateDiff(DateInterval.Day, DateSerial(2013, 1, 1), dtpExpDate.Value)
            lDec = Math.Ceiling(lDec / 15)  ' Demo Days is 15 OR 30 OR 45 OR 60 ....as on (Day calculate from 01-01-2013)
            dtpExpDate.Value = DateSerial(2013, 1, 1).AddDays(lDec * 15)
            txtDays.Text = DateDiff(DateInterval.Day, Now, dtpExpDate.Value)
        Catch ex As Exception
            'MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub txtLicNo_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles txtLicNo.KeyDown, txtLanUsers.KeyDown, txtDays.KeyDown
        If Not e.KeyData >= Keys.D0 And e.KeyData <= Keys.D9 Then
            e.Handled = True
        End If
    End Sub

    Private Sub lblTheroyalsoftware_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles lblTheroyalsoftware.LinkClicked
        System.Diagnostics.Process.Start("http://www.theroyalsoftware.com")
    End Sub

End Class

